#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>




int main(int argc, char *argv[]) {
  // Check for incorrect usage.
  if (argc != 2) {
    printf("Usage: shadowconverse <romname>\n");
    exit(1);
  }

  // Prepare some variables.
  char *romname = argv[1];
  int firstOffset = 0x167A;
  int length = 278;

  char* keywords[64] = {
    "Akimi         ",
    "Anders        ",
    "Aneki         ",
    "Arena         ",
    "Bremerton     ",
    "Calls         ",
    "Caryards      ",
    "Cortex Bomb   ",
    "Cyberware     ",
    "Dark Blade    ",
    "Datajack      ",
    "Decker        ",
    "Docks         ",
    "Dog           ",
    "Drake         ",
    "Examination   ",
    "Firearms      ",
    "Ghouls        ",
    "Glutman       ",
    "Grinder       ",
    "Head Computer ",
    "Heal          ",
    "Hiring        ",
    "HitMen        ",
    "Ice           ",
    "Jester Spirit ",
    "King          ",
    "Kitsune       ",
    "Laughlyn      ",
    "Lone Star     ",
    "Magic Fetish  ",
    "Maria         ",
    "Matrix Systems",
    "Mermaids      ",
    "Negotiation   ",
    "Nirwanda      ",
    "Norbert       ",
    "Nuyen         ",
    "Raitsov       ",
    "Rat           ",
    "Rust Stilettos",
    "Scalper       ",
    "Shadowrunners ",
    "Shaman        ",
    "Spare Word 1  ",
    "Spare Word 10 ",
    "Spare Word 11 ",
    "Spare Word 12 ",
    "Spare Word 2  ",
    "Spare Word 3  ",
    "Spare Word 4  ",
    "Spare Word 5  ",
    "Spare Word 7  ",
    "Spare Word 8  ",
    "Spare Word 9  ",
    "Steelflight   ",
    "Street Doc    ",
    "Strobes       ",
    "Talismans     ",
    "The Cage      ",
    "The Matrix    ",
    "Tickets       ",
    "Vampires      ",
    "Volcano       "
  };

  // Open the file.
  FILE *rom;
  rom = fopen(romname, "rb");
  if (!rom) {
    printf("Error: %s not found\n", romname);
    exit(1);
  }

  // Get the pointers.
  fseek(rom, firstOffset, SEEK_SET);
  unsigned char firstPointers[length];
  fread(firstPointers, sizeof(unsigned char), length, rom);



  int i, textAddress;
  unsigned char nextKeyword, bytesToSkip;
  char command[80];
  char textAddrAsString[20];

  for (i = 0; i < length; i += 2) {
    int conversationStart = firstPointers[i] + (256 * firstPointers[i+1]) + 0x60200;
    printf("%5X\n", conversationStart);
    fseek(rom, conversationStart, SEEK_SET);
    printf("Appearance     = %02X%02X%02X\n", fgetc(rom), fgetc(rom), fgetc(rom));
    printf("Unknown        = %02X\n", fgetc(rom));
    nextKeyword = fgetc(rom);

    while (nextKeyword != 0xF8) {
      switch (nextKeyword) {
        case 0xFF: printf("Introduction   = "); break;
        case 0xFE: printf("Talk To        = "); break;
        case 0xFD: printf("Default        = "); break;
        default:   printf("%s = ", keywords[nextKeyword]); break;
      }
      fflush(stdout);

      bytesToSkip = fgetc(rom);
      fseek(rom, (bytesToSkip - 3), SEEK_CUR);

      textAddress = fgetc(rom);
      textAddress += (256 * fgetc(rom));
      textAddress += 0xE8200;
      sprintf(textAddrAsString, " 0x%5X", textAddress);

      command[0] = '\0';
      strcat(command, "./shadowhuffman_2 ");
      strcat(command, romname);
      strcat(command, textAddrAsString);

      system(command);
      nextKeyword = fgetc(rom);
    }

    printf("\n");
  }



  fclose(rom);
  return 0;
}
